#include(CheckIncludeFileCXX)
include(CheckCXXSourceCompiles)
#include(CheckCXXSymbolExists)

# fold expressions (a + ...)
check_cxx_source_compiles("
  template <class... Args>
  int f(Args... args)
  {
    return (args + ...);
  }
  int main()
  {
    f(0,1,2,3,4,5);
  }
"  AMDIS_HAS_CXX_FOLD_EXPRESSION
)

check_cxx_source_compiles("
  template <int I>
  auto f()
  {
    if constexpr(I == 0)
      return double{1.0};
    else
      return int{0};
  }
  int main()
  {
    return f<1>();
  }
"  AMDIS_HAS_CXX_CONSTEXPR_IF
)